# Vault

### Secure, simple and fast password manager

[<img src="https://fdroid.gitlab.io/artwork/badge/get-it-on.png"
     alt="Get it on F-Droid"
     height="80">](https://f-droid.org/packages/com.arsvechkarev.vault/)
[<img src="https://play.google.com/intl/en_us/badges/images/generic/en-play-badge.png"
     alt="Get it on Google Play"
     height="80">](https://play.google.com/store/apps/details?id=com.arsvechkarev.vault)

#### Or download apk directly from [the latest release](https://github.com/arsvechkarev/Vault/releases/latest).

Vault is a password manager that helps you keep your passwords and other sensitive data organized. It is based on **kdbx** format that is used by [KeePass](https://keepass.info/), which means that it is compatible with every KeePass-based password manager. It is fast, secure and has an intuitive UX – everything you need from a reliable password manager.

> [!NOTE]
> Vault uses internet permission to download icons for passwords (you can find them [here](https://github.com/arsvechkarev/Vault/tree/master/icons/files)), but **no sensitive data like your master password or secret file is ever sent anywhere**. If you find this feature undesirable, you can disable it in app settings.

#### Screenshots:

<p float="left">
  <img src="screenshots/initial_screen.png" width="250" />
  <img src="screenshots/creating_master_password.png" width="250" /> 
  <img src="screenshots/login_biometrics.png" width="250" /> 
</p>
<p float="left">
  <img src="screenshots/main_list.png" width="250" />
  <img src="screenshots/settings.png" width="250" />
  <img src="screenshots/creating_new_password_entry.png" width="250" />  
</p>
<p float="left">
  <img src="screenshots/editing_password_screen.png" width="250" />
  <img src="screenshots/password_entry.png" width="250" />
  <img src="screenshots/note_entry.png" width="250" /> 
</p>
